/*
**************
			Created by: Cassandra McWade 2013
			Website: http://cassandramcwade.com
			Email: cas.TD@cassandramcwade.com
			For General Use

:Title:
Texture and File Copy Utility Main UI

:Purpose:

:Bugs:

:History:

:Include:

**************
SEPARATE SCRIPT DATA (TEST)
:To Do:
1. return list of all used material paths --DONE
2. fn to check whether or not the file is present
3. copy items --DONE
4. remap files (may not be needed)
5. UI display --DONE

:Problems:

:Timeline:
19/08/2013-- Script started
20/08/2013-- UI finalized
21/08/2013-- Step 1, 3 complete
*/
try(destroyDialog CopyTool.uiR)catch()

struct CopyTool
(	
--------DEFINED VARS TO USE
	mapFiles=#(),
	fileIO= undefined,
	fromPath=undefined,
	toPath=undefined,
	
--------USEABLE FNS
	fn addmap mapfile = 
	(
		local index=finditem mapfiles mapfile
		if index == 0 do append mapfiles mapfile
	),
	
--------ROLLOUTS
	uiR=
	(
		rollout uiR "Texture and File Copy Tool" width:400
		(
			subRollout KtoPSR "Copy Main to Secondary" width:160 height:160 align:#right across:2
			subRollout PtoKSR "Copy Secondary to Main" width:160 height:160 align:#left
			subRollout listSR "Whats Going On" width:(uiR.width) height:200 pos:[0,155]
			
			on uiR open do
			(
				uiR.height=350
				KtoPSR.height=uiR.height-10
				PtoKSR.height=uiR.height-10

				atsops.refresh()
				CopyTool.makeRollsFN()
			)
		)
	),
	
	KtoP=
	(
		rollout KtoP "Copy Main to Secondary"
		(
			button texKtoPBT "Copy Textures" pos:[20,20]
			groupBox overwriteGB "Overwrite Exisiting Files?" pos:[5,60] height:45 width:140
			checkbox KtoPY "Yes" across:2 pos:[20,80]
			checkbox KtoPN "No" pos:[80,80]
			label inSceneL "Only affects scene files" style_sunkenedge:true width:120 height:15 pos:[10,110]
			
			on texKtoPBT pressed do
			(
				copyTool.listRoll.fileStatPB.value=0
				enumeratefiles copytool.addmap
				ktopar=copytool.mapFiles
				
				For k in ktopar do 
				(
					if findString k "K:" != undefined then 
					(
						newK = replace k 1 3 "P:\\"
						newDirk= makeDir (getFilenamePath k) 
						copyFile k newK
					)
				)
				for k=1 to ktopar.count do
				(
					copyTool.listRoll.fileStatPB.color= green
					copyTool.listRoll.fileStatPB.value=(k/ktopar.count)*100
				)
				copytool.listRoll.listLB.items=ktopar
			)
		)
	),
	
	PtoK=
	(
		rollout PtoK "Copy from Secondary to Main" 
		(			
			button texPtoKBT "Copy Textures" pos:[20,20]
			groupBox overwriteGB "Overwrite Exisiting Files?" pos:[5,60] height:45 width:140
			checkbox PtoKY "Yes" across:2 pos:[20,80]
			checkbox PtoKN "No" pos:[80,80]
			label inSceneL "Only affects scene files" style_sunkenedge:true width:120 height:15 pos:[10,110]
			
			on texPtoKBT pressed do 
			(
				copyTool.listRoll.fileStatPB.value=0
				enumeratefiles copytool.addmap
				ar=copytool.mapFiles
				
				For m in ar do 
				(
					if findString m "P:" != undefined then 
					(
						newM = replace m 1 3 "K:\\"
						newDir= makeDir (getFilenamePath m) 
						copyFile m newM
					)
				)
				
				for m=1 to ar.count do
				(
					copyTool.listRoll.fileStatPB.color= green
					copyTool.listRoll.fileStatPB.value=(m/ar.count)*100
				)
				copytool.listRoll.listLB.items=ar
			)
		)
	),
	
	listRoll=
	(
		rollout listRoll "Status of Files" height:220
		(
			progressBar fileStatPB "Copying Status"
			listbox listLB 
			
			on fileStatPB clicked do
			(
				fileStatPB.value=0
			)
		)
	),
	
	
	fn makeRollsFN=
	(
		createDialog uiR()
		addSubRollout uiR.KtoPSR KtoP
		addSubRollout uiR.PtoKSR PtoK
		addSubRollout uir.listSR listRoll
	),
	
	fn runFN=
	(
		destroyDialog uiR
		createDialog uiR
	),
	
	fn getRollouts=#(uiR)
)
copyTool=copyTool()
copyTool.runFN()